openapi: 3.0.0

info:
  title: API списка покупок
  contact:
    name: Техподдержка Универсо
    url: https://www.universo.pro
    email: support@universo.pro
  version: '1.0'

servers:
  - url: https://cart.universo.pro
    description: Сервер обучения
  - url: http://127.0.0.1:3000
    description: Локальный сервер для отладки

paths:
  /api/carts:
    description: Коллекция корзин с покупками.
    get:
      summary: Получение списка корзин
      # description: Список корзин может фильтроваться и ограничиваться в размерах
      responses:
        200:
          description: Список корзин получен
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/Cart'

    post:
      summary: Создание новой корзины
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  example: Название корзины
      responses:
        200:
          description: Возвращает JSON с данными новой корзины
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Cart'

  /api/carts/{cart_id}:
    get:
      summary: Получение конкретной корзины
      parameters:
        - name: cart_id
          in: path
          required: true
          description: Идентификатор корзины
          schema:
            type: string
      responses:
        200:
          description: Конкретная корзина
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Cart'
    put:
      summary: Изменение всех данных корзины
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                id:
                  type: int64
                name:
                  type: string
                  example: Название корзины
    patch:
      summary: Изменение некоторых данных корзины
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  example: Название корзины
    delete:
      summary: Удаление корзины по её идентификатору
      parameters:
        - name: cart_id
          in: path
          required: true
          description: Идентификатор корзины
          schema:
            type: string
      responses:
        200:
          description: Конкретная корзина
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Cart'
        404:
          description: Корзина не найдена

  /api/carts/{cart_id}/items:
    post:
      summary: Создание нового элемента корзины
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                quantity:
                  type: int64
      responses:
        200:
          description: Возвращает JSON с данными новой корзины
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Cart'

  /api/carts/{cart_id}/items/{item_id}:
    # get:
    #   summary: Получение конкретного элемента корзины
    #   parameters:
    #     - name: cart_id
    #       in: path
    #       required: true
    #       description: Идентификатор корзины
    #       schema:
    #         type: int64
    #     - name: item_id
    #       in: path
    #       required: true
    #       description: Идентификатор элемента корзины
    #       schema:
    #         type: int64
    #   responses:
    #     200:
    #       description: Конкретная корзина
    #       content:
    #         application/json:
    #           schema:
    #             $ref: '#/components/schemas/CartItem'
    # put:
    #   summary: Изменение всех данных элемента корзины
    #   requestBody:
    #     required: true
    #     content:
    #       application/json:
    #         schema:
    #           $ref: '#/components/schemas/CartItem'
    patch:
      summary: Изменение некоторых данных корзины
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  example: Название элемента корзины
                quantity:
                  type: int64
                  example: Количество
    delete:
      summary: Удаление элемента корзины по его идентификатору
      parameters:
        - name: cart_id
          in: path
          required: true
          description: Идентификатор корзины
          schema:
            type: int64
        - name: item_id
          in: path
          required: true
          description: Идентификатор элемента корзины
          schema:
            type: int64
      responses:
        200:
          description: Конкретная корзина
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Cart'
        404:
          description: Корзина не найдена

  /api/users:
    get:
      summary: Получение списка пользователей
      parameters:
        - name: find
          in: query
          description: шаблон для поиска пользователя по имени и файмилии
          schema:
            type: string
      responses:
        200:
          description: Список найденных пользователей

components:
  schemas:
    Cart:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
    CartItem:
      type: object
      properties:
        id:
          type: int64
        name:
          type: string
        quantity:
          type: int64
        picked:
          type: boolean
    CartUser:
      type: object
      prperties:
        cart_id:
          type: int64
        user_id:
          type: uuid
        is_owner:
          type: boolean
    User:
      type: object
      properties:
        id:
          type: uuid
        profile:
          type: object
          properties:
            id:
              type: uuid
            first_name:
              type: string
            last_name:
              type: string
            sex:
              type: string
    Profile:
      type: object
      properties:
        id:
          type: uuid
        first_name:
          type: string
        last_name:
          type: string
        sex:
          type: string
